Attribute VB_Name = "Module1"
'QuickBasic BSAVE Image Viewer for Visual Basic 6.0
'
'Copyright 2003 Dmitry Brant, All Rights Reserved.

'Version 1.1, Last modified 09-27-2001
'
'me@dmitrybrant.com
'
'http://www.dmitrybrant.com


'Feel free to make improvements or optimizations to the program.
'If you do, please tell me or show me what you have done.

'This program is FREEWARE. Use freely, but give me credit
'where credit is due. (this program is NOT in the
'public domain). If you will use this source code in
'your software, the copyright notice stated above
'must be included in your source code and/or in the
'Help/About box of your program.

'The SOURCE CODE of this program, or portions of it, may not
'be redistributed, either by itself or in a compilation
'package, without express authorization from the author.

'ALL PRODUCT NAMES MENTIONED IN THIS SOFTWARE ARE TRADEMARKS
'OR REGISTERED TRADEMARKS OF THEIR RESPECTIVE OWNERS.

'THIS SOFTWARE IS DISTRIBUTED "AS IS". THE SOFTWARE IS
'DISTRIBUTED WITH NO WARRANTY, EIHER EXPRESSED
'OR IMPLIED, INCLUDING, BY WAY OF EXAMPLE THE IMPLIED
'WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
'PURPOSE. THE AUTHOR WILL NOT BE LIABLE FOR DATA LOSS, DAMAGES,
'LOSS OF PROFITS OR ANY OTHER KIND OF LOSS RESULTING FROM THE
'USE OR MISUSE OF THIS SOFTWARE.

Option Explicit
DefInt A-Z

Type BSVHeader
    Magic As Byte
    Segment As Integer
    Address As Integer
    Length As Integer
End Type

Declare Function SetPixel Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long

Sub DoBSV(FName As String, FObject As Object)
    Dim FWidth As Long, FHeight As Long
    Dim FColors As Integer, dx As Long, dy As Long
    Dim str1 As String, theHdc As Long
    Dim r As Integer, g As Integer, b As Integer
    Dim header As BSVHeader
    
    On Error GoTo ErrorTrap0
    
    Open FName For Binary As #1

    theHdc = FObject.hDC
    dx = 0: dy = 0
    Get #1, , header
    If header.Magic <> &HFD Then
        MsgBox "This is not a valid BSAVE file.", vbCritical, "Error."
    End If

    FWidth = 320
    FHeight = header.Length
    If FHeight < 0 Then FHeight = 65536 + FHeight
    FHeight = FHeight / 320

    ReDim Scan(0 To FWidth * FHeight) As Byte
    Get #1, , Scan
    Close #1
    For dy = 0 To 199
        For dx = 0 To 319
            r = Scan(dy * 320 + dx)
            SetPixel theHdc, dx, dy, RGB(r, r, r)
        Next dx
        If dy Mod 16 = 0 Then FObject.Refresh: theHdc = FObject.hDC
    Next dy
    Erase Scan
    Exit Sub

ErrorTrap0:
End Sub

